const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const trade_rule_checks = sequelize.define(
    'trade_rule_checks',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

result: {
        type: DataTypes.ENUM,
      
      

        values: [

"pass",


"fail",


"not_applicable"

        ],

      },

score: {
        type: DataTypes.DECIMAL,
      
      

      },

comment: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  trade_rule_checks.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity































//end loop



    db.trade_rule_checks.belongsTo(db.trades, {
      as: 'trade',
      foreignKey: {
        name: 'tradeId',
      },
      constraints: false,
    });

    db.trade_rule_checks.belongsTo(db.trade_rules, {
      as: 'trade_rule',
      foreignKey: {
        name: 'trade_ruleId',
      },
      constraints: false,
    });




    db.trade_rule_checks.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.trade_rule_checks.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return trade_rule_checks;
};


